from __future__ import absolute_import
from __future__ import division
from __future__ import print_function

import os
dir_path = os.path.abspath( os.path.join(os.path.dirname(os.path.realpath(__file__)), '..'))
import sys
sys.path.append(dir_path)

import time
import json

import tensorflow as tf

import cv2
import numpy as np

from myexp_conv_padissue_exp import *

import time

import tensorflow as tf
import tensorrt as trt
import graphsurgeon as gs
# import convert_to_uff_config
import uff
import os

import convert_to_uff_config

os.environ["CUDA_VISIBLE_DEVICES"]=""

_IMAGE_HEIGHT = 32



def freeze_moel(input_shape, output_node_names, output_path):
    # input_image = tf.placeholder(dtype=tf.float32, shape=input_shape)
    # initialise the net model

    config=tf.ConfigProto(allow_soft_placement=True)
    config.gpu_options.allow_growth = True
    sess = tf.Session(config=config)

    placeholder_tensor =  tf.placeholder(dtype=tf.float32, shape=input_shape)
    paddings = tf.constant([[0, 0], [3, 3],
                                [3, 3], [0, 0]])
    x = tf.pad(placeholder_tensor, paddings, "CONSTANT")
    image_tensor_tensor = conv_map(x,  32, 7, 2)
    # Initialization
    init = tf.global_variables_initializer()
    sess.run(init)

    writer = tf.summary.FileWriter(output_path, graph=tf.get_default_graph())

    saver = tf.train.Saver();
    saver.save(sess, output_path + '/cnn_bilstm.ckpt')

    frozen_graph_def = tf.graph_util.convert_variables_to_constants(
        sess,
        tf.get_default_graph().as_graph_def(),
        output_node_names = output_node_names
    )

    frozen_graph_def = tf.graph_util.remove_training_nodes(frozen_graph_def)

    output_path = '.' if output_path == None else output_path

    with tf.gfile.GFile(output_path + '/frozen_model.pb', 'wb') as f:
        f.write(frozen_graph_def.SerializeToString())

    return frozen_graph_def

def convert_pb_to_uff(input_shape, output_node_names, frozen_graph, output_path):
    dyn_graph = gs.DynamicGraph(frozen_graph)

    convert_to_uff_config.preprocess(dyn_graph, input_shape=input_shape)
    uff_model = uff.from_tensorflow(
        dyn_graph.as_graph_def(),
        output_filename=output_path + '/frozen_model.uff',
        output_nodes=output_node_names,
        text=True
    )

    # static_graph = gs.StaticGraph(dyn_graph)
    # static_graph.write_tensorboard(output_path)

def main():
    input_shape = [1, 361, 641, 3]
    output_node_names = ['transpose']
    frozen_model = freeze_moel(input_shape, output_node_names, './pre-trained')
    convert_pb_to_uff(input_shape, output_node_names, frozen_model, './pre-trained')

if __name__ == '__main__':
    main()

